"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class gps_t(object):
    __slots__ = ["timestamp", "lat", "latdir", "lon", "londir", "altitude", "eastings", "northings"]

    def __init__(self):
        self.timestamp = 0.0
        self.lat = 0.0
        self.latdir = ""
        self.lon = 0.0
        self.londir = ""
        self.altitude = 0.0
        self.eastings = 0.0
        self.northings = 0.0

    def encode(self):
        buf = BytesIO()
        buf.write(gps_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">ff", self.timestamp, self.lat))
        __latdir_encoded = self.latdir.encode('utf-8')
        buf.write(struct.pack('>I', len(__latdir_encoded)+1))
        buf.write(__latdir_encoded)
        buf.write(b"\0")
        buf.write(struct.pack(">f", self.lon))
        __londir_encoded = self.londir.encode('utf-8')
        buf.write(struct.pack('>I', len(__londir_encoded)+1))
        buf.write(__londir_encoded)
        buf.write(b"\0")
        buf.write(struct.pack(">fff", self.altitude, self.eastings, self.northings))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != gps_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return gps_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = gps_t()
        self.timestamp, self.lat = struct.unpack(">ff", buf.read(8))
        __latdir_len = struct.unpack('>I', buf.read(4))[0]
        self.latdir = buf.read(__latdir_len)[:-1].decode('utf-8', 'replace')
        self.lon = struct.unpack(">f", buf.read(4))[0]
        __londir_len = struct.unpack('>I', buf.read(4))[0]
        self.londir = buf.read(__londir_len)[:-1].decode('utf-8', 'replace')
        self.altitude, self.eastings, self.northings = struct.unpack(">fff", buf.read(12))
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if gps_t in parents: return 0
        tmphash = (0xc851d55116a0d2d3) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if gps_t._packed_fingerprint is None:
            gps_t._packed_fingerprint = struct.pack(">Q", gps_t._get_hash_recursive([]))
        return gps_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

